package tapl3

import combinatorParsing.{BuildingParsers, Position, TokenizingParsers}

/** This object implements a parser and evaluator for the
 *  untyped lambda calculus found in Chapter 9 of
 *  the TAPL book.
 */
object SimplyTyped extends TokenizingParsers with BuildingParsers with TestSuite {
  // to be completed
  keywords.incl(/* to be completed*/ "->")

  /** <pre>
   *  Term     ::= SimpleTerm { SimpleTerm }</pre>
   */
  def Term: Parser = production(
    // to be completed
    failure("illegal start of term"))

  /** <pre>
   *  SimpleTerm ::= "true"
   *               | "false"
   *               | number
   *               | "succ" Term
   *               | "pred" Term
   *               | "iszero" Term
   *               | "if" Term "then" Term "else" Term
   *               | ident
   *               | "\" ident ":" Type "." Term
   *               | "(" Term ")"
   *               | "let" ident ":" Type "=" Term "in" Term</pre>
   */
  def SimpleTerm: Parser = production(
    // to be completed
    failure("illegal start of simple term"))

  /** <pre>
   *  Type       ::= SimpleType { "->" Type }</pre>
   */
  def Type: Parser = production(
    // to be completed
    failure("illegal start of type"))

  /** <pre>
   *  SimpleType ::= "Bool" | "Nat" | "(" Type ")"</pre>
   */
  def SimpleType: Parser = production(
    // to be completed
    failure("illegal start of simple type"))

  type Output = Term

  import implicitConversions._

  override def build(xs: List[Token], pos: Position): Output =
    null // to be replaced (see exercise 2)

  def parse(in: String): Option[Output] = {
    val res = run(Term, in.replaceAll("->", " -> "))
    res match {
      case Success(_, _) => output(res)
      case Failure(_, _) => Console.println(res); None
    }
  }

  // to be completed (see exercise 2)

  /** Full beta reduction.
   *
   *  @param t the initial term
   *  @return  the reduced term
   */
  def reduce(t: Term): Term =
    t // to be replaced (see exercise 2)

  /** Call by value reducer. */
  def reduceWithCallByValue(t: Term): Term =
    t // to be replaced (see exercise 2)

  /** Returns a stream of terms, each being one step of reduction.
   *
   *  @param t      the initial term
   *  @param reduce the evaluation strategy used for reduction.
   *  @return       the stream of terms representing the big reduction.
   */
  def path(t: Term, reduce: Term => Term): Stream[Term] =
    Stream.empty // to be replaced (see exercise 2)

  /** Returns the type of the given term <code>t</code>.
   *
   *  @param ctx the initial context
   *  @param t   the given term
   *  @return    the computed type
   */
  def typeof(ctx: Context, t: Term): Type =
    null // to be replaced

  def main(args: Array[String]): Unit = {
    checkString("""(\x:Bool.x) true""")
    Console.println
    checkString("""(\x:Bool->(Bool->Bool).x) (\x:Bool.\y:Bool.x)""")
/*
    Console.println
    checkString("""(\x:Nat. x) 1""")
    Console.println
    checkString("""(\x:(Nat->Nat) -> Nat. x) y""")
    Console.println
    if (args.length < 1) {
      Console.println("usage: tapl3.SimplyTyped <file>")
      exit(1)
    }
    check(args(0))
*/
  }
}
